/**
 *******************************************************************************
 * @file    uart_block.c
 *
 * @brief   Implement system specific functions.
 *
 * @author  DP
 *
 * @version V1.0.1
 *
 * @date    2024-11-11
 *
 *******************************************************************************/

/*
    Copyright (c) 2024, DP Microelectronics Inc.

    Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

    1. Redistributions of source code must retain the above copyright notice, this
       list of conditions and the following disclaimer.
    2. Redistributions in binary form must reproduce the above copyright notice,
       this list of conditions and the following disclaimer in the documentation
       and/or other materials provided with the distribution.
    3. Neither the name of the copyright holder nor the names of its contributors
       may be used to endorse or promote products derived from this software without
       specific prior written permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.
*/

/* Files include */
#include "uart_block.h"

/**
  * @addtogroup DPM32M036_LibSamples
  * @{
  */

/**
  * @addtogroup UART
  * @{
  */

/**
  * @addtogroup UART Printf
  * @{
  */

/* Private typedef --------------------------------------------------------------*/

/* Private define ---------------------------------------------------------------*/

/* Private macro ----------------------------------------------------------------*/

/* Private variables ------------------------------------------------------------*/
uint16_t tx_buf[5] = {0x11, 0x22, 0x44, 0x88, 0xAA};
uint16_t tx_size=5;
uint16_t rx_buf[30] = {0};
uint16_t rx_size=30;
/* Private functions ------------------------------------------------------------*/

/**
 *******************************************************************************
 * @brief   UART GPIO Config.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void UART_GPIOConfig(void)
{
  /* Enable clock */
  RCC_Unlock();
  RCC_AHBPeriphClockCmd(RCC_AHB_PERIPH_GPIO, ENABLE);
  RCC_Lock();

  /* connect port to UARTx Pin */
  GPIO_InitTypeStruct GPIO_InitStruct;
  GPIO_StructInit(&GPIO_InitStruct);
  GPIO_InitStruct.GPIO_Mode = GPIO_MODE_ALT_FUNC;
  GPIO_InitStruct.GPIO_Speed = GPIO_SPEED_HIGH;
  GPIO_InitStruct.GPIO_OType =  GPIO_OTYPE_PP;
  GPIO_InitStruct.GPIO_PuPd = GPIO_PUPD_NOPULL;

  GPIO_InitStruct.GPIO_Pin =  GPIO_PIN_9 | GPIO_PIN_10;
  GPIO_Init(GPIOA, &GPIO_InitStruct);
  GPIO_AltFuncConfig(GPIOA, GPIO_PIN_9 | GPIO_PIN_10, GPIO_ALT_FUNC_1);
}

/**
 *******************************************************************************
 * @brief   UART Config.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void UART_ConfigInit(void)
{
  /* Enable clock */
  RCC_Unlock();
  RCC_APBPeriphClockCmd(RCC_APB_PERIPH_UART0, ENABLE);
  RCC_Lock();

  /* UART configure */
  UART_DeInit(UART0);
  UART_InitTypeStruct UART_InitStruct;
  UART_StructInit(&UART_InitStruct);
  UART_InitStruct.UART_BaudRate = 115200;
  UART_InitStruct.UART_DataLen = UART_DATA_LEN_8;
  UART_InitStruct.UART_StopBits = UART_STOP_BITS_1;
  UART_InitStruct.UART_Parity = UART_PARITY_NO;
  UART_InitStruct.UART_Mode = UART_MODE_RX_TX;
  UART_Init(UART0, &UART_InitStruct);
  UART_Cmd(UART0, ENABLE);
}
/**
 *******************************************************************************
 * @brief   UART Block Sample.
 * @param   None.
 * @retval  None.
 ******************************************************************************/
void UART_Block_Sample(void)
{
  uint32_t cnt = 0;

  /* Config uart0 GPIO */ 
  UART_GPIOConfig();
  
  /* Config uart0 */
  UART_ConfigInit();
  
  /* Send data */
  while(cnt < tx_size)
  {
    if(UART_GetIntFlagStatus(UART0, UART_INT_FLAG_TXE) == SET)
    {
      UART_SendData(UART0, tx_buf[cnt++]);
    }
  }  
  
  cnt =0;
  
  /* Receive data */
  while(cnt < rx_size)
  {
    if(UART_GetIntFlagStatus(UART0, UART_INT_FLAG_RXNE) == SET)
    {
      rx_buf[cnt] = UART_ReceiveData(UART0);
      /* print receive data */
      UART_SendData(UART0, rx_buf[cnt]);
      cnt++;
    }    
  }
}

/* retarget the C library printf function to the usart */
int fputc(int ch, FILE *f)
{
  UART_SendData(UART0, (uint8_t)ch);

  while(RESET == UART_GetIntFlagStatus(UART0, UART_INT_FLAG_TXE));

  return ch;
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT DP *****END OF FILE ***************************/
